blob: 229e2019ddd9c5b1a16e841a3f5fbb847c93378d [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010044export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010059 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070060fi
61
Orion Hodson64fe3be2018-06-15 12:50:22 +010062export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070063
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Dan Willemsen12371e92017-03-06 17:55:20 -080079# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
80# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
81export OUT_DIR=${OUT_DIR:-out}
82if [[ "$OUT_DIR" != /* ]]; then
83 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
84fi
85
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086# ANDROID_HOST_OUT is not set in a build environment.
87if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080088 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089fi
90
Igor Murashkine5181932017-06-15 16:03:50 -070091# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070092if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070093 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
94fi
95
Igor Murashkin271a0f82017-02-14 21:14:17 +000096# Zipalign is not on the PATH in some configs, auto-detect it.
97if [ -z "$ZIPALIGN" ]; then
98 if which zipalign >/dev/null; then
99 ZIPALIGN="zipalign";
100 else
101 # TODO: Add a dependency for zipalign in Android.run-test.mk
102 # once it doesn't depend on libandroidfw (b/35246701)
103 case "$OSTYPE" in
104 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
105 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
106 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
107 esac
108 fi
109fi
110export ZIPALIGN
111
David Brazdil122c6632018-01-24 17:32:49 +0000112# If hiddenapi was not set by the environment variable, assume it is in
113# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000114if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000115 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000116fi
117
Roland Levillain76cfe612017-10-30 13:14:28 +0000118chroot=
119
jeffhao5d1ac922011-09-29 17:41:15 -0700120info="info.txt"
121build="build"
122run="run"
123expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700124check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700125output="output.txt"
126build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100127cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700128strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700129lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700130testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700131run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000132build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700133
Alex Light91de25f2015-10-28 17:00:06 -0700134quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000135debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700136prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700137target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700138dev_mode="no"
139update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700140debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000141relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800142runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700143usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700144build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700145suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700146trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700147trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700148basic_verify="false"
149gc_verify="false"
150gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700151jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700152jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700153jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700154jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700155strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700156always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700157never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700158have_image="yes"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000159android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700160bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800161suspend_timeout="500000"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000162image_suffix=""
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100163run_optimizing="false"
jeffhao5d1ac922011-09-29 17:41:15 -0700164
165while true; do
166 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700167 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700168 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100169 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700170 shift
Alex Light91de25f2015-10-28 17:00:06 -0700171 elif [ "x$1" = "x--quiet" ]; then
172 quiet="yes"
173 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700174 elif [ "x$1" = "x--use-java-home" ]; then
175 if [ -n "${JAVA_HOME}" ]; then
176 export JAVA="${JAVA_HOME}/bin/java"
177 export JAVAC="${JAVA_HOME}/bin/javac -g"
178 else
179 echo "Passed --use-java-home without JAVA_HOME variable set!"
180 usage="yes"
181 fi
182 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800183 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700184 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800185 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800186 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700187 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700188 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100189 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700190 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800191 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700192 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700193 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700194 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700195 shift
196 elif [ "x$1" = "x--dalvik" ]; then
197 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800198 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700199 shift
Alex Light03a112d2014-08-25 13:25:56 -0700200 elif [ "x$1" = "x--no-image" ]; then
201 have_image="no"
202 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700203 elif [ "x$1" = "x--relocate" ]; then
204 relocate="yes"
205 shift
206 elif [ "x$1" = "x--no-relocate" ]; then
207 relocate="no"
208 shift
209 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100210 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700211 prebuild_mode="yes"
212 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800213 elif [ "x$1" = "x--compact-dex-level" ]; then
214 option="$1"
215 shift
216 run_args="${run_args} $option $1"
217 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700218 elif [ "x$1" = "x--strip-dex" ]; then
219 run_args="${run_args} --strip-dex"
220 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000221 elif [ "x$1" = "x--debuggable" ]; then
222 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000223 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000224 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700225 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100226 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700227 prebuild_mode="no"
228 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700229 elif [ "x$1" = "x--gcverify" ]; then
230 basic_verify="true"
231 gc_verify="true"
232 shift
233 elif [ "x$1" = "x--gcstress" ]; then
234 basic_verify="true"
235 gc_stress="true"
236 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700237 elif [ "x$1" = "x--jvmti-step-stress" ]; then
238 jvmti_step_stress="true"
239 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700240 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
241 jvmti_redefine_stress="true"
242 shift
Alex Light43e935d2017-06-19 15:40:40 -0700243 elif [ "x$1" = "x--jvmti-field-stress" ]; then
244 jvmti_field_stress="true"
245 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700246 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
247 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700248 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800249 elif [ "x$1" = "x--suspend-timeout" ]; then
250 shift
251 suspend_timeout="$1"
252 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700253 elif [ "x$1" = "x--image" ]; then
254 shift
255 image="$1"
256 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700257 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000258 elif [ "x$1" = "x-Xcompiler-option" ]; then
259 shift
260 option="$1"
261 run_args="${run_args} -Xcompiler-option $option"
262 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000263 elif [ "x$1" = "x--build-option" ]; then
264 shift
265 option="$1"
266 build_args="${build_args} $option"
267 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700268 elif [ "x$1" = "x--runtime-option" ]; then
269 shift
270 option="$1"
271 run_args="${run_args} --runtime-option $option"
272 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700273 elif [ "x$1" = "x--gdb-arg" ]; then
274 shift
275 gdb_arg="$1"
276 run_args="${run_args} --gdb-arg $gdb_arg"
277 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700278 elif [ "x$1" = "x--debug" ]; then
279 run_args="${run_args} --debug"
280 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700281 elif [ "x$1" = "x--debug-wrap-agent" ]; then
282 run_args="${run_args} --debug-wrap-agent"
283 shift
Alex Light0e151e72017-10-25 10:50:35 -0700284 elif [ "x$1" = "x--with-agent" ]; then
285 shift
286 option="$1"
287 run_args="${run_args} --with-agent $1"
288 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700289 elif [ "x$1" = "x--debug-agent" ]; then
290 shift
291 option="$1"
292 run_args="${run_args} --debug-agent $1"
293 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700294 elif [ "x$1" = "x--gdb" ]; then
295 run_args="${run_args} --gdb"
296 dev_mode="yes"
297 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700298 elif [ "x$1" = "x--strace" ]; then
299 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700300 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700301 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700302 elif [ "x$1" = "x--zygote" ]; then
303 run_args="${run_args} --zygote"
304 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800305 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000306 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700307 image_suffix="-interpreter"
308 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800309 elif [ "x$1" = "x--jit" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100310 run_args="${run_args} --jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000311 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800312 shift
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100313 elif [ "x$1" = "x--baseline" ]; then
314 run_args="${run_args} --baseline"
315 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700316 elif [ "x$1" = "x--optimizing" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100317 run_optimizing="true"
jeffhao0dff3f42012-11-20 15:13:43 -0800318 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700319 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700320 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700321 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700322 elif [ "x$1" = "x--verify-soft-fail" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100323 run_args="${run_args} --verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700324 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700325 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700326 elif [ "x$1" = "x--no-optimize" ]; then
327 run_args="${run_args} --no-optimize"
328 shift
329 elif [ "x$1" = "x--no-precise" ]; then
330 run_args="${run_args} --no-precise"
331 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700332 elif [ "x$1" = "x--invoke-with" ]; then
333 shift
334 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700335 if [ "x$what" = "x" ]; then
336 echo "$0 missing argument to --invoke-with" 1>&2
337 usage="yes"
338 break
339 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700340 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700341 shift
342 elif [ "x$1" = "x--dev" ]; then
343 run_args="${run_args} --dev"
344 dev_mode="yes"
345 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700346 elif [ "x$1" = "x--build-only" ]; then
347 build_only="yes"
348 shift
349 elif [ "x$1" = "x--output-path" ]; then
350 shift
351 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700352 if [ "x$tmp_dir" = "x" ]; then
353 echo "$0 missing argument to --output-path" 1>&2
354 usage="yes"
355 break
356 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700357 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000358 elif [ "x$1" = "x--chroot" ]; then
359 shift
360 if [ "x$1" = "x" ]; then
361 echo "$0 missing argument to --chroot" 1>&2
362 usage="yes"
363 break
364 fi
365 chroot="$1"
366 run_args="${run_args} --chroot $1"
367 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000368 elif [ "x$1" = "x--android-root" ]; then
369 shift
370 if [ "x$1" = "x" ]; then
371 echo "$0 missing argument to --android-root" 1>&2
372 usage="yes"
373 break
374 fi
375 android_root="$1"
376 run_args="${run_args} --android-root $1"
377 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700378 elif [ "x$1" = "x--update" ]; then
379 update_mode="yes"
380 shift
381 elif [ "x$1" = "x--help" ]; then
382 usage="yes"
383 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700384 elif [ "x$1" = "x--64" ]; then
385 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700386 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700387 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200388 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700389 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200390 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700391 elif [ "x$1" = "x--stream" ]; then
392 trace_stream="true"
393 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700394 elif [ "x$1" = "x--always-clean" ]; then
395 always_clean="yes"
396 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700397 elif [ "x$1" = "x--never-clean" ]; then
398 never_clean="yes"
399 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800400 elif [ "x$1" = "x--dex2oat-swap" ]; then
401 run_args="${run_args} --dex2oat-swap"
402 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700403 elif [ "x$1" = "x--instruction-set-features" ]; then
404 shift
405 run_args="${run_args} --instruction-set-features $1"
406 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700407 elif [ "x$1" = "x--bisection-search" ]; then
408 bisection_search="yes"
409 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000410 elif [ "x$1" = "x--vdex" ]; then
411 run_args="${run_args} --vdex"
412 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000413 elif [ "x$1" = "x--dm" ]; then
414 run_args="${run_args} --dm"
415 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000416 elif [ "x$1" = "x--vdex-filter" ]; then
417 shift
418 filter=$1
419 run_args="${run_args} --vdex-filter $filter"
420 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700421 elif [ "x$1" = "x--random-profile" ]; then
422 run_args="${run_args} --random-profile"
423 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700424 elif [ "x$1" = "x--dex2oat-jobs" ]; then
425 shift
426 run_args="${run_args} -Xcompiler-option -j$1"
427 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700428 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700429 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700430 usage="yes"
431 break
432 else
433 break
434 fi
435done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700436
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100437if [ "$usage" = "no" -a "x$1" = "x" ]; then
438 echo "missing test to run" 1>&2
439 usage="yes"
440fi
441
Roland Levillain76cfe612017-10-30 13:14:28 +0000442# The DEX_LOCATION with the chroot prefix, if any.
443chroot_dex_location="$chroot$DEX_LOCATION"
444
Alex Light91de25f2015-10-28 17:00:06 -0700445# Allocate file descriptor real_stderr and redirect it to the shell's error
446# output (fd 2).
447if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
448 exec {real_stderr}>&2
449else
450 # In bash before version 4.1 we need to do a manual search for free file
451 # descriptors.
452 FD=3
453 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
454 real_stderr=$FD
455 eval "exec ${real_stderr}>&2"
456fi
457if [ "$quiet" = "yes" ]; then
458 # Force the default standard output and error to go to /dev/null so we will
459 # not print them.
460 exec 1>/dev/null
461 exec 2>/dev/null
462fi
463
464function err_echo() {
465 echo "$@" 1>&${real_stderr}
466}
467
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700468# tmp_dir may be relative, resolve.
469#
470# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000471# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700472# Cannot use readlink -m, as it does not exist on Mac.
473# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700474noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700475tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700476mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700477
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800478# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000479if [ ! "$runtime" = "jvm" ]; then
480 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
481fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800482
Alex Lighte7873ec2014-08-12 09:53:50 -0700483if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800484 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
485 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700486fi
487if [ "$gc_verify" = "true" ]; then
488 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
489fi
490if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700491 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700492fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700493if [ "$jvmti_redefine_stress" = "true" ]; then
494 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
495fi
Alex Lightc38c3692017-06-27 15:45:14 -0700496if [ "$jvmti_step_stress" = "true" ]; then
497 run_args="${run_args} --no-app-image --jvmti-step-stress"
498fi
Alex Light43e935d2017-06-19 15:40:40 -0700499if [ "$jvmti_field_stress" = "true" ]; then
500 run_args="${run_args} --no-app-image --jvmti-field-stress"
501fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700502if [ "$jvmti_trace_stress" = "true" ]; then
503 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700504fi
Jeff Hao85139a32014-07-23 11:52:52 -0700505if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700506 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
507 if [ "$trace_stream" = "true" ]; then
508 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
509 # the ability to analyze the file and just write to /dev/null.
510 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
511 # Enable streaming mode.
512 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
513 else
514 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
515 fi
516elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700517 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700518 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700519fi
520
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700521# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000522# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100523function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700524 # Check whether this is a device with native bridge. Currently this is hardcoded
525 # to x86 + arm.
526 x86_arm=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | sort | grep -E '^(arm|x86)$'`
527 # Collapse line-breaks into spaces
528 x86_arm=$(echo $x86_arm)
529 if [ "x$x86_arm" = "xarm x86" ] ; then
530 err_echo "Native-bridge configuration detected."
531 # We only support the main arch for tests.
532 if [ "x${suffix64}" = "x64" ]; then
533 target_arch_name=""
534 else
535 target_arch_name=x86
536 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700537 else
Andreas Gamped0566d42018-06-06 09:54:34 -0700538 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
539 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
540 if [ "x${suffix64}" = "x64" ]; then
541 target_arch_name=${grep64bit}
542 else
543 target_arch_name=${grep32bit}
544 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700545 fi
546}
547
David Brazdil853a4c32015-09-28 16:15:50 +0100548function guess_host_arch_name() {
549 if [ "x${suffix64}" = "x64" ]; then
550 host_arch_name="x86_64"
551 else
552 host_arch_name="x86"
553 fi
554}
555
Alex Lighta59dd802014-07-02 16:28:08 -0700556if [ "$target_mode" = "no" ]; then
557 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700558 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700559 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000560 exit 1
561 fi
562 else
563 # ART/Dalvik host mode.
564 if [ -n "$chroot" ]; then
565 err_echo "--chroot with --host is unsupported"
566 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700567 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700568 fi
569fi
570
Jeff Hao201803f2013-11-20 18:11:39 -0800571if [ ! "$runtime" = "jvm" ]; then
572 run_args="${run_args} --lib $lib"
573fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700574
Jeff Hao201803f2013-11-20 18:11:39 -0800575if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700576 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000577 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800578 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700579 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700580 else
581 true # defaults to using target BOOTCLASSPATH
582 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800583elif [ "$runtime" = "art" ]; then
584 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100585 guess_host_arch_name
Vladimir Marko4519b9d2018-10-10 15:21:21 +0100586 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700587 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800588 else
David Brazdil853a4c32015-09-28 16:15:50 +0100589 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800590 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Vladimir Marko4519b9d2018-10-10 15:21:21 +0100591 run_args="${run_args} --boot /data/art-test/core${image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800592 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700593 if [ "$relocate" = "yes" ]; then
594 run_args="${run_args} --relocate"
595 else
596 run_args="${run_args} --no-relocate"
597 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700598elif [ "$runtime" = "jvm" ]; then
599 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800600 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700601fi
602
Alex Light03a112d2014-08-25 13:25:56 -0700603if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700604 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700605 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700606 exit 1
607 fi
Alex Light03a112d2014-08-25 13:25:56 -0700608 run_args="${run_args} --no-image"
609fi
610
jeffhao5d1ac922011-09-29 17:41:15 -0700611if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700612 err_echo "--dev and --update are mutually exclusive"
613 usage="yes"
614fi
615
616if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
617 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700618 usage="yes"
619fi
620
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700621if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
622 err_echo "--bisection-search and --prebuild are mutually exclusive"
623 usage="yes"
624fi
625
Roland Levillain76cfe612017-10-30 13:14:28 +0000626# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
627if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
628 err_echo "--chroot with --bisection-search is unsupported"
629 exit 1
630fi
631
jeffhao5d1ac922011-09-29 17:41:15 -0700632if [ "$usage" = "no" ]; then
633 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
634 test_dir=`basename "$oldwd"`
635 else
636 test_dir="$1"
637 fi
638
639 if [ '!' -d "$test_dir" ]; then
640 td2=`echo ${test_dir}-*`
641 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700642 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700643 usage="yes"
644 fi
645 test_dir="$td2"
646 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700647 # Shift to get rid of the test name argument. The rest of the arguments
648 # will get passed to the test run.
649 shift
650fi
651
652if [ "$usage" = "yes" ]; then
653 prog=`basename $prog`
654 (
655 echo "usage:"
656 echo " $prog --help Print this message."
657 echo " $prog [options] [test-name] Run test normally."
658 echo " $prog --dev [options] [test-name] Development mode" \
659 "(dumps to stdout)."
660 echo " $prog --update [options] [test-name] Update mode" \
661 "(replaces expected.txt)."
662 echo ' Omitting the test name or specifying "-" will use the' \
663 "current directory."
664 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000665 echo " -O Run non-debug rather than debug build (off by default)."
666 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000667 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000668 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800669 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700670 echo " --debug Wait for the default debugger to attach."
671 echo " --debug-agent <agent-path>"
672 echo " Wait for the given debugger agent to attach. Currently"
673 echo " only supported on host."
674 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
675 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700676 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000677 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000678 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700679 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000680 echo " --build-only Build test files only (off by default)."
681 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800682 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000683 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000684 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700685 echo " --verify-soft-fail Force soft fail verification (off by default)."
686 echo " Verification is enabled if neither --no-verify"
687 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000688 echo " --no-optimize Turn off optimization (on by default)."
689 echo " --no-precise Turn off precise GC (on by default)."
690 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700691 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000692 echo " other runtime options are ignored."
693 echo " --no-dex2oat Run as though dex2oat was failing."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000694 echo " --prebuild Run dex2oat on the files before starting test. (default)"
695 echo " --no-prebuild Do not run dex2oat on the files before starting"
696 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700697 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000698 echo " --relocate Force the use of relocating in the test, making"
699 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000700 echo " address before running."
701 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700702 echo " --image Run the test using a precompiled boot image. (default)"
703 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000704 echo " --host Use the host-mode virtual machine."
705 echo " --invoke-with Pass --invoke-with option to runtime."
706 echo " --dalvik Use Dalvik (off by default)."
707 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700708 echo " --use-java-home Use the JAVA_HOME environment variable"
709 echo " to find the java compiler and runtime"
710 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000711 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700712 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000713 echo " --64 Run the test in 64-bit mode"
714 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700715 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700716 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000717 echo " --gcstress Run with gc stress testing"
718 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700719 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700720 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700721 echo " --jvmti-redefine-stress"
722 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000723 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700724 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000725 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000726 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000727 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700728 echo " --instruction-set-features [string]"
729 echo " Set instruction-set-features for compilation."
Alex Light91de25f2015-10-28 17:00:06 -0700730 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700731 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000732 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800733 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700734 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700735 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700736 exit 1
737fi
738
739cd "$test_dir"
740test_dir=`pwd`
741
742td_info="${test_dir}/${info}"
743td_expected="${test_dir}/${expected}"
744
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700745if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700746 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700747 exit 1
748fi
749
750if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700751 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700752 exit 1
753fi
754
755# copy the test to a temp dir and run it
756
Elliott Hughes510c8782011-10-06 10:57:34 -0700757echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700758
759rm -rf "$tmp_dir"
Alex Light0aa7a5a2018-10-10 15:58:14 +0000760cp -LRp "$test_dir" "$tmp_dir"
jeffhao5d1ac922011-09-29 17:41:15 -0700761cd "$tmp_dir"
762
763if [ '!' -r "$build" ]; then
764 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800765else
766 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700767fi
768
769if [ '!' -r "$run" ]; then
770 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800771else
772 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700773fi
774
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700775if [ '!' -r "$check_cmd" ]; then
776 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800777else
778 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700779fi
780
jeffhao5d1ac922011-09-29 17:41:15 -0700781chmod 755 "$build"
782chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700783chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700784
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700785export TEST_NAME=`basename ${test_dir}`
786
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000787# Tests named '<number>-checker-*' will also have their CFGs verified with
788# Checker when compiled with Optimizing on host.
789if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100790 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$run_optimizing" = "true" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000791 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
792 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
793 run_checker="yes"
794
795 if [ "$target_mode" = "no" ]; then
796 cfg_output_dir="$tmp_dir"
797 checker_args="--arch=${host_arch_name^^}"
798 else
799 cfg_output_dir="$DEX_LOCATION"
800 checker_args="--arch=${target_arch_name^^}"
801 fi
802
803 if [ "$debuggable" = "yes" ]; then
804 checker_args="$checker_args --debuggable"
805 fi
806
807 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
808 -Xcompiler-option -j1"
809 fi
810 fi
811fi
812
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100813run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700814
Richard Uhler020c0f32017-03-14 16:23:17 +0000815# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
816# ART output to approximately 128MB. This should be more than sufficient
817# for any test while still catching cases of runaway output.
818# Set a hard limit to encourage ART developers to increase the ulimit here if
819# needed to support a test case rather than resetting the limit in the run
820# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000821if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000822 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700823fi
824
Igor Murashkin2de6e082018-02-28 15:25:23 -0800825# Tell the build script which mode (target, host, jvm) we are building for
826# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000827if [[ "$target_mode" == "yes" ]]; then
828 build_args="$build_args --target"
829else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800830 if [[ $runtime == "jvm" ]]; then
831 build_args="$build_args --jvm"
832 else
833 build_args="$build_args --host"
834 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000835fi
836
837if [[ "$dev_mode" == "yes" ]]; then
838 build_args="$build_args --dev"
839fi
840
jeffhao5d1ac922011-09-29 17:41:15 -0700841good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000842good_build="yes"
843good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700844export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700845if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000846 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700847 build_exit="$?"
848 echo "build exit status: $build_exit" 1>&2
849 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800850 echo "${test_dir}: running..." 1>&2
851 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700852 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000853
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800854 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000855 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100856 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000857 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100858 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100859 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000860 checker_exit="$?"
861 if [ "$checker_exit" = "0" ]; then
862 good="yes"
863 fi
Alex Light91de25f2015-10-28 17:00:06 -0700864 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000865 else
866 good="yes"
867 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800868 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000869 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700870 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700871elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000872 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700873 build_exit="$?"
874 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800875 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700876 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000877 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100878 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000879 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100880 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100881 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000882 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700883 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
884 good="yes"
885 else
Alex Light91de25f2015-10-28 17:00:06 -0700886 cat "$build_output" 1>&${real_stderr} 1>&2
887 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700888 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700889elif [ "$build_only" = "yes" ]; then
890 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000891 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700892 build_exit="$?"
893 if [ "$build_exit" '!=' '0' ]; then
894 cp "$build_output" "$output"
895 echo "build exit status: $build_exit" >>"$output"
896 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
897 if [ "$?" '!=' "0" ]; then
898 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700899 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700900 fi
901 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700902 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700903 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700904 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700905else
David Brazdil4846d132015-01-15 19:07:08 +0000906 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700907 build_exit="$?"
908 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800909 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700910 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000911 run_exit="$?"
912 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700913 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000914 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000915 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100916 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000917 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100918 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100919 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000920 checker_exit="$?"
921 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700922 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000923 good_run="no"
924 else
925 good_run="yes"
926 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000927 else
928 good_run="yes"
929 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700930 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000931 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700932 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700933 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
934 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700935 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700936 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700937 max_name_length=$(getconf NAME_MAX ${tmp_dir})
938 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
939 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700940 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700941 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700942 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700943 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000944 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
945 # output == expected
946 good="yes"
947 echo "${test_dir}: succeeded!" 1>&2
948 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700949 fi
950fi
951
jeffhao5d1ac922011-09-29 17:41:15 -0700952(
Alex Lightbfac14a2014-07-30 09:41:21 -0700953 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700954 echo "${test_dir}: FAILED!"
955 echo ' '
956 echo '#################### info'
957 cat "${td_info}" | sed 's/^/# /g'
958 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700959 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700960 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700961 if [ "$strace" = "yes" ]; then
962 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700963 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700964 echo '####################'
965 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700966 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
967 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
968 # tools used by the given ABI work for both x86 and x86-64.
969 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
970 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700971 echo ' '
972 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700973
Alex Light91de25f2015-10-28 17:00:06 -0700974) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700975
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700976# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +0000977# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700978if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
979 # Bisecting works by skipping different optimization passes which breaks checker assertions.
980 if [ "$run_checker" == "yes" ]; then
981 echo "${test_dir}: not bisecting, checker test." 1>&2
982 else
983 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700984 echo "${test_dir}: bisecting..." 1>&2
985 cwd=`pwd`
986 maybe_device_mode=""
987 raw_cmd=""
988 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000989 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700990 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
991 # to exec in order to preserve pid when calling dalvikvm. This is required
992 # for bisection search to correctly retrieve logs from device.
993 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +0000994 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700995 maybe_device_mode="--device"
996 raw_cmd="$DEX_LOCATION/cmdline.sh"
997 else
998 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
999 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001000 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001001 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1002 $maybe_device_mode \
1003 --raw-cmd="$raw_cmd" \
1004 --check-script="$cwd/check" \
1005 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001006 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001007 --timeout=300
1008 fi
1009fi
1010
Alex Lightbfac14a2014-07-30 09:41:21 -07001011# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001012if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001013 cd "$oldwd"
1014 rm -rf "$tmp_dir"
1015 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001016 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001017 fi
1018 if [ "$good" = "yes" ]; then
1019 exit 0
1020 fi
1021fi
1022
1023
1024(
1025 if [ "$always_clean" = "yes" ]; then
1026 echo "${TEST_NAME} files deleted from host "
1027 if [ "$target_mode" == "yes" ]; then
1028 echo "and from target"
1029 fi
1030 else
1031 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1032 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001033 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001034 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001035 fi
1036
Alex Light91de25f2015-10-28 17:00:06 -07001037) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001038
Alex Light6a870fa2016-05-31 16:36:19 -07001039if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1040 exit 0
1041else
1042 exit 1
1043fi